"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatName = exports.toSnakeCase = exports.toCamelCase = exports.upperFirst = void 0;
function upperFirst(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
exports.upperFirst = upperFirst;
function toCamelCase(str) {
    return str.replace(/(?:^\w|[A-Z]|\b\w)/g, function (word, index) {
        return index === 0 ? word.toLowerCase() : word.toUpperCase();
    }).replace(/\s+/g, '');
}
exports.toCamelCase = toCamelCase;
function toSnakeCase(str) {
    return str.replace(/\.?([A-Z]+)/g, function (x, y) { return '_' + y.toLowerCase(); }).replace(/^_/, '');
}
exports.toSnakeCase = toSnakeCase;
function isUpperCase(str) {
    return str === str.toUpperCase();
}
function formatName(config, name) {
    switch (config.NamingConvention) {
        case 'camelCase':
            if (isUpperCase(name)) {
                return name.toLowerCase();
            }
            return toCamelCase(name);
        case 'pascalCase': return upperFirst(name);
        case 'snakeCase': return toSnakeCase(name);
        default: return upperFirst(name);
    }
}
exports.formatName = formatName;
