"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toOriginalMethodComment = exports.createMethodComments = exports.constructorComments = exports.initialCreateValidationString = exports.toolsString = exports.DataTypesMap = void 0;
exports.DataTypesMap = {
    char: 'string',
    varchar: 'string',
    text: 'string',
    tinytext: 'string',
    mediumtext: 'string',
    longtext: 'string',
    time: 'string',
    geometry: 'string',
    set: 'string',
    enum: 'string',
    integer: 'number',
    int: 'number',
    smallint: 'number',
    mediumint: 'number',
    bigint: 'number',
    double: 'number',
    decimal: 'number',
    numeric: 'number',
    float: 'number',
    year: 'number',
    tinyint: 'boolean',
    json: 'Object',
    date: 'string',
    datetime: 'string',
    timestamp: 'string',
    tinyblob: 'Buffer',
    mediumblob: 'Buffer',
    longblob: 'Buffer',
    blob: 'Buffer',
    binary: 'Buffer',
    varbinary: 'Buffer',
    bit: 'Buffer',
};
exports.toolsString = "export function throwNull2NonNull(field: string, d: any): never {\n    return errorHelper(field, d, 'non-nullable object', false);\n}\n\n/**\n * Throw an error when value is not array\n * @param d Meaning data\n * @param nullable Is this field nullable\n * @param field The field name\n */\nexport function throwNotObject(field: string, d: any, nullable: boolean): never {\n    return errorHelper(field, d, 'object', nullable);\n}\n\n/**\n * Throw an error when value is not array\n * @param d Meaning data\n * @param nullable Is this field nullable\n * @param field The field name\n */\nexport function throwIsArray(field: string, d: any, nullable: boolean): never {\n    return errorHelper(field, d, 'object', nullable);\n}\n\n/**\n * Checks if the value is a number\n * @param d Meaning data\n * @param nullable Is this field nullable\n * @param field The field name\n */\nexport function checkNumber(d: any, nullable: boolean, field: string): void {\n    if (typeof (d) !== 'number' && (!nullable || (nullable && d !== null && d !== undefined))) {\n        errorHelper(field, d, 'number', nullable);\n    }\n}\n\n/**\n * Checks if the value is a boolean\n * @param d Meaning data\n * @param nullable Is this field nullable\n * @param field The field name\n */\nexport function checkBoolean(d: any, nullable: boolean, field: string): void {\n    if (typeof (d) !== 'boolean' && (!nullable || (nullable && d !== null && d !== undefined))) {\n        errorHelper(field, d, 'boolean', nullable);\n    }\n}\n\n/**\n * Checks if the value is a string\n * @param d Meaning data\n * @param nullable Is this field nullable\n * @param field The field name\n */\nexport function checkString(d: any, nullable: boolean, field: string): void {\n    if (typeof (d) !== 'string' && (!nullable || (nullable && d !== null && d !== undefined))) {\n        errorHelper(field, d, 'string', nullable);\n    }\n}\n\n/**\n * Helps to create an understandable error message\n * @param field The field name that is being checked\n * @param d Meaning data\n * @param type That the type should be\n * @param nullable Is this field nullable or not\n */\nexport function errorHelper(field: string, d: any, type: string, nullable: boolean): never {\n    if (nullable) {\n        type += ', null, or undefined';\n    }\n    throw new TypeError('Expected ' + type + ' at ' + field + ' but found:\n' + JSON.stringify(d));\n}\n\n/**\n * Checks if the value is array or not\n * @param d Meaning data\n * @param field The field name\n */\nexport function checkArray(d: any, field: string): void {\n    if (!Array.isArray(d) && d !== null && d !== undefined) {\n        errorHelper(field, d, 'array', true);\n    }\n}\n";
exports.initialCreateValidationString = "        if (obj === null || obj === undefined) {\n            throwNull2NonNull(field, obj);\n        } else if (typeof (obj) !== 'object') {\n            throwNotObject(field, obj, false);\n        } else if (Array.isArray(obj)) {\n            throwIsArray(field, obj, false);\n        }";
exports.constructorComments = "    /**\n     * The default constructor of AddressType class\n     * @param obj prepared object\n     */";
exports.createMethodComments = "    /**\n     * Validates and creates sub models if they exists\n     * @param obj a javascript object\n     * @param field needed for errorHelper\n     */";
exports.toOriginalMethodComment = "    /**\n     * Revert the object to original json object\n     * @param json Should return the json or not\n     */";
