"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeneratorService = void 0;
var fs_1 = require("fs");
var config_service_1 = require("./config-service");
var validator_service_1 = require("./validator-service");
var inversify_1 = require("inversify");
var mysql_service_1 = require("./mysql-service");
var tools_service_1 = require("./tools-service");
var values_1 = require("../models/values");
var path_1 = require("path");
var chalk = require("chalk");
var utils_1 = require("../core/utils");
var GeneratorService = /** @class */ (function () {
    function GeneratorService(validatorService, mysqlService, toolsService, configService) {
        this.toolsService = toolsService;
        this.mysqlService = mysqlService;
        this.configService = configService;
        this.validatorService = validatorService;
    }
    GeneratorService.prototype.generate = function () {
        return __awaiter(this, void 0, void 0, function () {
            var start, config, tables, end;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        start = +new Date();
                        config = this.configService.getConfig();
                        return [4 /*yield*/, this.toolsService.initializeMysql()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.toolsService.useDatabase(config.DatabaseName)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.toolsService.getTables()];
                    case 3:
                        tables = _a.sent();
                        return [4 /*yield*/, this.exportTables(tables)];
                    case 4:
                        _a.sent();
                        end = +new Date() - start;
                        console.log(chalk.green("Models generated successfully in " + end + "ms"));
                        process.exit(0);
                        return [2 /*return*/];
                }
            });
        });
    };
    GeneratorService.prototype.exportTables = function (tables) {
        return __awaiter(this, void 0, void 0, function () {
            var config, outputDirectory, _i, tables_1, table;
            return __generator(this, function (_a) {
                try {
                    config = this.configService.getConfig();
                    outputDirectory = path_1.isAbsolute(config.OutputDirectory) ? config.OutputDirectory : process.cwd() + '/' + config.OutputDirectory;
                    if (!fs_1.existsSync(outputDirectory)) {
                        fs_1.mkdirSync(outputDirectory);
                    }
                    for (_i = 0, tables_1 = tables; _i < tables_1.length; _i++) {
                        table = tables_1[_i];
                        fs_1.writeFileSync(outputDirectory + "/" + utils_1.toCamelCase(table.name) + ".model.ts", table.getClassDefinitionString(config));
                    }
                    if (config.Mode === 'advanced') {
                        fs_1.writeFileSync(outputDirectory + "/needed-utils.ts", values_1.toolsString);
                    }
                }
                catch (error) {
                    console.log('error: ', error.message);
                    process.exit(1);
                }
                return [2 /*return*/];
            });
        });
    };
    GeneratorService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(validator_service_1.Validator)),
        __param(1, inversify_1.inject(mysql_service_1.MysqlService)),
        __param(2, inversify_1.inject(tools_service_1.ToolsService)),
        __param(3, inversify_1.inject(config_service_1.ConfigService))
    ], GeneratorService);
    return GeneratorService;
}());
exports.GeneratorService = GeneratorService;
