"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MysqlService = void 0;
var mysql_1 = require("mysql");
var config_service_1 = require("./config-service");
var inversify_1 = require("inversify");
var MysqlService = /** @class */ (function () {
    function MysqlService(configService) {
        this.connection = {};
        this.configService = configService;
    }
    MysqlService.prototype.initialize = function () {
        var _this = this;
        var config = this.configService.getConfig();
        this.connection = mysql_1.createConnection({
            host: config.DatabaseHost,
            user: config.DatabaseUsername,
            password: config.DatabasePassword,
            port: +config.DatabasePort,
        });
        return new Promise(function (resolve, reject) {
            _this.connection.connect(function (err) {
                if (err) {
                    return reject(err);
                }
                return resolve();
            });
        });
    };
    MysqlService.prototype.executeQuery = function (sql) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.connection.query(sql, function (err, result) {
                if (err) {
                    return reject(err);
                }
                return resolve(result);
            });
        });
    };
    MysqlService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(config_service_1.ConfigService))
    ], MysqlService);
    return MysqlService;
}());
exports.MysqlService = MysqlService;
