"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolsService = void 0;
var config_service_1 = require("./config-service");
var inversify_1 = require("inversify");
var mysql_service_1 = require("./mysql-service");
var column_1 = require("../models/column");
var table_1 = require("../models/table");
var chalk = require("chalk");
var values_1 = require("../models/values");
var ToolsService = /** @class */ (function () {
    function ToolsService(mysqlService, configService) {
        this.mysqlService = mysqlService;
        this.configService = configService;
    }
    ToolsService.prototype.useDatabase = function (databaseName) {
        return __awaiter(this, void 0, void 0, function () {
            var error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.mysqlService.executeQuery('USE ' + databaseName)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        console.log('error: ', error_1);
                        process.exit(1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ToolsService.prototype.initializeMysql = function () {
        return __awaiter(this, void 0, void 0, function () {
            var error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        console.log(chalk.blue('Connecting to database...'));
                        return [4 /*yield*/, this.mysqlService.initialize()];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        error_2 = _a.sent();
                        console.log('Could not connect to database:', error_2);
                        process.exit(1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ToolsService.prototype.getTables = function () {
        return __awaiter(this, void 0, void 0, function () {
            var config, tablesResult, tables, _i, tablesResult_1, tableResult, tName, _a, _b, _c, _d, error_3;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        config = this.configService.getConfig();
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 7, , 8]);
                        console.log(chalk.blue('Getting tables...'));
                        return [4 /*yield*/, this.mysqlService.executeQuery('SHOW TABLES')];
                    case 2:
                        tablesResult = _e.sent();
                        tables = [];
                        _i = 0, tablesResult_1 = tablesResult;
                        _e.label = 3;
                    case 3:
                        if (!(_i < tablesResult_1.length)) return [3 /*break*/, 6];
                        tableResult = tablesResult_1[_i];
                        tName = tableResult['Tables_in_' + config.DatabaseName];
                        _b = (_a = tables).push;
                        _c = table_1.Table.bind;
                        _d = [void 0, tName];
                        return [4 /*yield*/, this.getColumns(tName)];
                    case 4:
                        _b.apply(_a, [new (_c.apply(table_1.Table, _d.concat([_e.sent()])))()]);
                        _e.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/, tables];
                    case 7:
                        error_3 = _e.sent();
                        console.log('error: ', error_3);
                        process.exit(1);
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    ToolsService.prototype.getColumns = function (tableName) {
        return __awaiter(this, void 0, void 0, function () {
            var columnsResult, columns, _i, columnsResult_1, columnResult, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        console.log(chalk.blue('Getting "' + tableName + '" columns...'));
                        return [4 /*yield*/, this.mysqlService.executeQuery('DESCRIBE ' + tableName)];
                    case 1:
                        columnsResult = _a.sent();
                        columns = [];
                        for (_i = 0, columnsResult_1 = columnsResult; _i < columnsResult_1.length; _i++) {
                            columnResult = columnsResult_1[_i];
                            columns.push(new column_1.Column(columnResult.Field, this.getTypescriptType(columnResult.Type), columnResult.Null == 'YES'));
                        }
                        return [2 /*return*/, columns];
                    case 2:
                        error_4 = _a.sent();
                        console.log('error: ', error_4);
                        process.exit(1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ToolsService.prototype.getTypescriptType = function (type) {
        var types = values_1.DataTypesMap;
        var foundType = '';
        for (var key in types) {
            if (types.hasOwnProperty(key)) {
                var element = types[key];
                if (type.includes(key)) {
                    foundType = element;
                    break;
                }
            }
        }
        if (!foundType) {
            return 'any';
        }
        else {
            return foundType;
        }
    };
    ToolsService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(mysql_service_1.MysqlService)),
        __param(1, inversify_1.inject(config_service_1.ConfigService))
    ], ToolsService);
    return ToolsService;
}());
exports.ToolsService = ToolsService;
